#ifndef ELDBUS_MODEL_METHOD_EO_HH
#define ELDBUS_MODEL_METHOD_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_model.eo.h"
#include "eldbus_model_arguments.eo.h"
#include "eldbus_model_method.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_model.eo.hh"
#include "eldbus_model_arguments.eo.hh"
#include "eo_base.eo.hh"
namespace eldbus { namespace model { 
struct Method;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::eldbus::model::Method> : ::std::true_type {}; } }

namespace eo_cxx {
namespace eldbus { namespace model { 
struct Method {
   ::efl::eolian::return_traits<void>::type call() const;
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_METHOD_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::eldbus::model::Method() const;
   operator ::eldbus::model::Method&();
   operator ::eldbus::model::Method const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Method,  ::efl::Model,  ::eldbus::model::Arguments,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Method const ,  ::efl::Model const ,  ::eldbus::model::Arguments const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace eldbus { namespace model { 
struct Method : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Model)
   , EO_CXX_INHERIT( ::eldbus ::model::Arguments)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Method( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Method(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Method(Method const& other) = default;
   Method(Method&& other) = default;
   Method& operator=(Method const& other) = default;
   Method& operator=(Method&& other) = default;
   Method()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Method( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Method(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type call() const;
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_METHOD_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct successful_call_event
   {
      static Eo_Event_Description const* description()
      { return ELDBUS_MODEL_METHOD_EVENT_SUCCESSFUL_CALL; }
      typedef void parameter_type;
   } const successful_call_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Method,  ::efl::Model,  ::eldbus::model::Arguments,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Method const ,  ::efl::Model const ,  ::eldbus::model::Arguments const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Method) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Method>::value, "");
} } 
#include "eldbus_model_method.eo.impl.hh"
#endif
